# Copyright 2024- Le Filament (https://le-filament.com)
# License AGPL-3.0 or later (http://www.gnu.org/licenses/agpl.html)

from odoo import fields, models


class AccountInvoiceReport(models.Model):
    _inherit = "account.invoice.report"

    membership_state = fields.Selection(
        [
            ("none", "Non Membre"),
            ("canceled", "Membre Annulé"),
            ("old", "Ancien Membre"),
            ("waiting", "Membre en attente"),
            ("invoiced", "Membre facturé"),
            ("free", "Membre libre"),
            ("paid", "Membre payant"),
        ],
        string="Statut d'adhésion actuel",
        readonly=True,
    )
    region_id = fields.Many2one(
        "afac.partner.region", string="Région implantation", readonly=True
    )
    legal_status_id = fields.Many2one(
        "afac.partner.legal", string="Statut juridique", readonly=True
    )
    legal_status_detail_id = fields.Many2one(
        "afac.partner.legal.detail", string="Statut juridique détaillé", readonly=True
    )

    # ------------------------------------------------------
    # Fields declaration
    # ------------------------------------------------------

    # ------------------------------------------------------
    # SQL Constraints
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Default methods
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Computed fields / Search Fields
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Onchange / Constraints
    # ------------------------------------------------------

    # ------------------------------------------------------
    # CRUD methods (ORM overrides)
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Actions
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Business methods
    # ------------------------------------------------------
    def _select(self):
        return (
            super(AccountInvoiceReport, self)._select()
            + """,
            partner.membership_state as membership_state,
            partner.region_id as region_id,
            partner.legal_status_id as legal_status_id,
            partner.legal_status_detail_id as legal_status_detail_id
            """
        )
